package main;
use Evo;
use FindBin;
use lib "$FindBin::Bin/../../lib";
use Test::More;

{

  # Without ::
  package MyAwesomeBase;
  use Evo -class;
  has foo_awesome => 'foo';

  # doesn't have new method
  package My::NotEvo;
  use Evo -loaded;
  sub foo_notevo {'foo'}

  package My::Obj;
  use Evo 'MyAwesomeBase::', 'My::NotEvo', 'MyExternal::';

};

my $obj = My::Obj->new;
isa_ok($obj, 'Evo::Class::Base');
isa_ok($obj, 'My::Obj');
isa_ok($obj, 'MyAwesomeBase');
isa_ok($obj, 'My::NotEvo');
isa_ok($obj, 'MyExternal');

is $obj->foo_awesome,  'foo';
is $obj->foo_external, 'foo';
is $obj->foo_notevo,   'foo';


done_testing;
